#include <libgcc.h>

long long __divti3(long long a, long long b) {
	long long out;
	out = __udivdi3((a >= 0 ? a : -a), (b >= 0 ? b : -b));
	if((a >> 63) == (b >> 63))
		return out;
	return -out;
}

unsigned long long __udivti3(unsigned long long a, unsigned long long b) {
	unsigned long a_upper = (a >> 32);
	unsigned long b_upper = (b >> 32);

	if(b_upper > 0)
		return (a_upper / b_upper);

	unsigned long a_lower = a;
	unsigned long b_lower = b;
	unsigned long long out;
	out = (a_upper / b_lower);
	out <<= 32;
	out += ((a_upper % b_lower) / b_lower);
	out += (a_lower / b_lower);
	return out;
}

long __divdi3(long a, long b) {
	long tempOut;
	__asm__ volatile (
		"div     %1, %2\n"
		"mflo    %0\n"
		: "=r"(tempOut) : "r"(a), "r"(b));
	return tempOut;
}

unsigned long __udivdi3(unsigned long a, unsigned long b) {
	long tempOut;
	__asm__ volatile (
		"divu    %1, %2\n"
		"mflo    %0\n"
		: "=r"(tempOut) : "r"(a), "r"(b));
	return tempOut;
}
